<html>
<head>
<title>Ogre::Quaternion Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="#pub-static-attribs">Static Public Attributes</a> &#124;
<a href="#friends">Friends</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::Quaternion Class Reference<div class="ingroups"><a class="el" href="group__Math.html">Math</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::Quaternion" -->
<p>Implementation of a <a class="el" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>, i.e.  
 <a href="classOgre_1_1Quaternion.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>&gt;</code></p>

<p><a href="classOgre_1_1Quaternion-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#ab58dc0c4c04d0579ce9321a719f10d5c">Quaternion</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Default constructor, initializes to identity rotation (aka 0°)  <a href="#ab58dc0c4c04d0579ce9321a719f10d5c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a9b45997a81d85662350808b7043d535d">Quaternion</a> (<a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> fW, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> fX, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> fY, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> fZ)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct from an explicit list of values.  <a href="#a9b45997a81d85662350808b7043d535d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#acdcb70a4f122452b6fa70d7cf5ce3cf3">Quaternion</a> (const <a class="el" href="classOgre_1_1Matrix3.html">Matrix3</a> &amp;rot)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct a quaternion from a rotation matrix.  <a href="#acdcb70a4f122452b6fa70d7cf5ce3cf3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a7f25c623d95186b58f6367dcd097a5ba">Quaternion</a> (const <a class="el" href="classOgre_1_1Radian.html">Radian</a> &amp;rfAngle, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkAxis)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct a quaternion from an angle/axis.  <a href="#a7f25c623d95186b58f6367dcd097a5ba"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a1140011dc0793a81c55f2d078c8c964c">Quaternion</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;xaxis, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;yaxis, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;zaxis)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct a quaternion from 3 orthonormal local axes.  <a href="#a1140011dc0793a81c55f2d078c8c964c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a3ccc60338011887023b397a02a7f3336">Quaternion</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> *akAxis)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct a quaternion from 3 orthonormal local axes.  <a href="#a3ccc60338011887023b397a02a7f3336"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a1ca81bd9d57e43cf23582c898e5fdd34">Quaternion</a> (<a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> *valptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct a quaternion from 4 manual w/x/y/z values.  <a href="#a1ca81bd9d57e43cf23582c898e5fdd34"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a54dcd575915c7b7ddb65b8cb249de521">swap</a> (<a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;other)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Exchange the contents of this quaternion with another.  <a href="#a54dcd575915c7b7ddb65b8cb249de521"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a3f9320930fd5110028abf48c78a89622">operator[]</a> (const size_t i) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Array accessor operator.  <a href="#a3f9320930fd5110028abf48c78a89622"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a074aea0da7fabfde89d204a1f0f0121b">operator[]</a> (const size_t i)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Array accessor operator.  <a href="#a074aea0da7fabfde89d204a1f0f0121b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#aecce24dd0096766de0c96c13b195b197">ptr</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Pointer accessor for direct copying.  <a href="#aecce24dd0096766de0c96c13b195b197"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#ab4b5bc328439a4f96d1b4b413fcf87cc">ptr</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Pointer accessor for direct copying.  <a href="#ab4b5bc328439a4f96d1b4b413fcf87cc"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#ae6c3bfed7176355cf2461567f89a15b1">FromRotationMatrix</a> (const <a class="el" href="classOgre_1_1Matrix3.html">Matrix3</a> &amp;kRot)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a7e6b9955074bf92c2b778dc0307769a2">ToRotationMatrix</a> (<a class="el" href="classOgre_1_1Matrix3.html">Matrix3</a> &amp;kRot) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#ac3328c1bb86d17e870c57d52720e2e32">FromAngleAxis</a> (const <a class="el" href="classOgre_1_1Radian.html">Radian</a> &amp;rfAngle, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkAxis)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Setups the quaternion using the supplied vector, and "roll" around that vector by the specified radians.  <a href="#ac3328c1bb86d17e870c57d52720e2e32"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a9c516d6b499410b2fc72524026d3a124">ToAngleAxis</a> (<a class="el" href="classOgre_1_1Radian.html">Radian</a> &amp;rfAngle, <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkAxis) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a77b776c2f81d371549927b0f79478eb9">ToAngleAxis</a> (<a class="el" href="classOgre_1_1Degree.html">Degree</a> &amp;dAngle, <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkAxis) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a7ad7ad40e38bf351485c2a906c3949bb">FromAxes</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> *akAxis)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructs the quaternion using 3 axes, the axes are assumed to be orthonormal.  <a href="#a7ad7ad40e38bf351485c2a906c3949bb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a365bc3b10308318721199a829db03887">FromAxes</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;<a class="el" href="classOgre_1_1Quaternion.html#ad6d7ef864ec7bf39db133a0fd67cce26">xAxis</a>, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;<a class="el" href="classOgre_1_1Quaternion.html#a62b05272a53c6ee664d7ed6760ec3744">yAxis</a>, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;<a class="el" href="classOgre_1_1Quaternion.html#a6c1b8112a4af61982f0feb6fe187851c">zAxis</a>)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a82b3a7b187451d70e1522b54718deadf">ToAxes</a> (<a class="el" href="classOgre_1_1Vector3.html">Vector3</a> *akAxis) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the 3 orthonormal axes defining the quaternion.  <a href="#a82b3a7b187451d70e1522b54718deadf"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#afc19f98e4b1cf72072a5da398c8702ba">ToAxes</a> (<a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;<a class="el" href="classOgre_1_1Quaternion.html#ad6d7ef864ec7bf39db133a0fd67cce26">xAxis</a>, <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;<a class="el" href="classOgre_1_1Quaternion.html#a62b05272a53c6ee664d7ed6760ec3744">yAxis</a>, <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;<a class="el" href="classOgre_1_1Quaternion.html#a6c1b8112a4af61982f0feb6fe187851c">zAxis</a>) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#ad6d7ef864ec7bf39db133a0fd67cce26">xAxis</a> (void) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the X orthonormal axis defining the quaternion.  <a href="#ad6d7ef864ec7bf39db133a0fd67cce26"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a62b05272a53c6ee664d7ed6760ec3744">yAxis</a> (void) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the Y orthonormal axis defining the quaternion.  <a href="#a62b05272a53c6ee664d7ed6760ec3744"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a6c1b8112a4af61982f0feb6fe187851c">zAxis</a> (void) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the Z orthonormal axis defining the quaternion.  <a href="#a6c1b8112a4af61982f0feb6fe187851c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a6367b543cf0d073d893139dd503b4fbd">operator=</a> (const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rkQ)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a3c71782cbc1d79c25d1374ffde29f918">operator+</a> (const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rkQ) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#ab07f890193a498d4091c3cbc6799ae4f">operator-</a> (const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rkQ) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a8b6d98bd2af93072ee558a2fb8e41b61">operator*</a> (const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rkQ) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a629aca4f4c26ecf88b5755872629cf0a">operator*</a> (<a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> fScalar) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a425964da3f7cc72e656d68cec30833d0">operator-</a> () const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#aa20c618a3b4b67d22d2cfd64ba2c8f3b">operator==</a> (const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rhs) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#aaac827806910efa70a5deaa6d75bf3e1">operator!=</a> (const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rhs) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a8ed59783cae74b10d60c5dfab65efc46">Dot</a> (const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rkQ) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the dot product of the quaternion.  <a href="#a8ed59783cae74b10d60c5dfab65efc46"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a17a0e63655eda5e7d77522d45033668c">Norm</a> () const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#aee94ec9c7de50fe7f774ae4c7e760b65">normalise</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Normalises this quaternion, and returns the previous length.  <a href="#aee94ec9c7de50fe7f774ae4c7e760b65"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a391f1c24de70342cc0ac3945d9450ef6">Inverse</a> () const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a9bac18de9a5b0935834e045b2a755d4f">UnitInverse</a> () const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#afa5a360df739f21929b2359276c2a9a5">Exp</a> () const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#aa446f6210a2446c7ff3a9358635988c4">Log</a> () const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#aa453e5f1a2e1de06bfacf89433a9b529">operator*</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkVector) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Rotation of a vector by a quaternion.  <a href="#aa453e5f1a2e1de06bfacf89433a9b529"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Radian.html">Radian</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a4d02aa80d2d2183045225a0243e659b9">getRoll</a> (bool reprojectAxis=true) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculate the local roll element of this quaternion.  <a href="#a4d02aa80d2d2183045225a0243e659b9"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Radian.html">Radian</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#ab4f38aa582a50dd81c05c3e772680f6b">getPitch</a> (bool reprojectAxis=true) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculate the local pitch element of this quaternion.  <a href="#ab4f38aa582a50dd81c05c3e772680f6b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Radian.html">Radian</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a76afd1ec6ae605cf6a969a5e57873f5e">getYaw</a> (bool reprojectAxis=true) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculate the local yaw element of this quaternion.  <a href="#a76afd1ec6ae605cf6a969a5e57873f5e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a2967ddfe51904c9bff1b68eb3e39f0e5">equals</a> (const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rhs, const <a class="el" href="classOgre_1_1Radian.html">Radian</a> &amp;tolerance) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Equality with tolerance (tolerance is max angle difference)  <a href="#a2967ddfe51904c9bff1b68eb3e39f0e5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a2b1de9aebae545618e105399aeee6f39">isNaN</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Check whether this quaternion contains valid values.  <a href="#a2b1de9aebae545618e105399aeee6f39"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#ab0c47f1a7308ac4c17db9f9ddb6e4a72">Slerp</a> (<a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> fT, const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rkP, const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rkQ, bool shortestPath=false)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Performs Spherical linear interpolation between two quaternions, and returns the result.  <a href="#ab0c47f1a7308ac4c17db9f9ddb6e4a72"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a25fb3bc0f11e6a676fb5c47347a79579">SlerpExtraSpins</a> (<a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> fT, const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rkP, const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rkQ, int iExtraSpins)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a838d0736819d496073d99f3f74d0cac1">Intermediate</a> (const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rkQ0, const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rkQ1, const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rkQ2, <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rka, <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rkB)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a5f43da8b8aa579e02035eecff89e16a5">Squad</a> (<a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> fT, const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rkP, const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rkA, const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rkB, const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rkQ, bool shortestPath=false)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a16987149991882e148170fe3f1c7da4b">nlerp</a> (<a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> fT, const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rkP, const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rkQ, bool shortestPath=false)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Performs Normalised linear interpolation between two quaternions, and returns the result.  <a href="#a16987149991882e148170fe3f1c7da4b"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#af3424f1e07092c0ffe293d18b277a04f">w</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a32c5680516b41bc4ba3159bf4d4abaf1">x</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#aa7328cd3883a92ee9c9322805d038f11">y</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a31ec84a931236554c0c17e37bf5ace97">z</a></td></tr>
<tr><td colspan="2"><h2><a name="pub-static-attribs"></a>
Static Public Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static const <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a6b53296360cc166c62533cff8f1edcc2">msEpsilon</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Cutoff for sine near zero.  <a href="#a6b53296360cc166c62533cff8f1edcc2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a44f3c000c8f1ea2759c2e724e04bf86b">ZERO</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a441b8d52549e1dedec27420325a313ef">IDENTITY</a></td></tr>
<tr><td colspan="2"><h2><a name="friends"></a>
Friends</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> friend <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#ab929010aac9fae8a14008a7213d9d419">operator*</a> (<a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> fScalar, const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rkQ)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> friend std::ostream &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Quaternion.html#a2a92fc4c7d55783c70ef6f633f3cac89">operator&lt;&lt;</a> (std::ostream &amp;o, const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;q)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Function for writing to a stream.  <a href="#a2a92fc4c7d55783c70ef6f633f3cac89"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Implementation of a <a class="el" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>, i.e. </p>
<p>a rotation around an axis. For more information about Quaternions and the theory behind it, we recommend reading: <a href="http://www.ogre3d.org/tikiwiki/Quaternion+and+Rotation+Primer">http://www.ogre3d.org/tikiwiki/Quaternion+and+Rotation+Primer</a> <a href="http://www.cprogramming.com/tutorial/3d/quaternions.html">http://www.cprogramming.com/tutorial/3d/quaternions.html</a> <a href="http://www.gamedev.net/page/resources/_/reference/programming/math-and-physics/">http://www.gamedev.net/page/resources/_/reference/programming/math-and-physics/</a> quaternions/quaternion-powers-r1095 </p>

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00057">57</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="ab58dc0c4c04d0579ce9321a719f10d5c"></a><!-- doxytag: member="Ogre::Quaternion::Quaternion" ref="ab58dc0c4c04d0579ce9321a719f10d5c" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Quaternion.html#ab58dc0c4c04d0579ce9321a719f10d5c">Ogre::Quaternion::Quaternion</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Default constructor, initializes to identity rotation (aka 0°) </p>

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00061">61</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

</div>
</div>
<a class="anchor" id="a9b45997a81d85662350808b7043d535d"></a><!-- doxytag: member="Ogre::Quaternion::Quaternion" ref="a9b45997a81d85662350808b7043d535d" args="(Real fW, Real fX, Real fY, Real fZ)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Quaternion.html#ab58dc0c4c04d0579ce9321a719f10d5c">Ogre::Quaternion::Quaternion</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>fW</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>fX</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>fY</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>fZ</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Construct from an explicit list of values. </p>

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00066">66</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

</div>
</div>
<a class="anchor" id="acdcb70a4f122452b6fa70d7cf5ce3cf3"></a><!-- doxytag: member="Ogre::Quaternion::Quaternion" ref="acdcb70a4f122452b6fa70d7cf5ce3cf3" args="(const Matrix3 &amp;rot)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Quaternion.html#ab58dc0c4c04d0579ce9321a719f10d5c">Ogre::Quaternion::Quaternion</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix3.html">Matrix3</a> &amp;&#160;</td>
          <td class="paramname"><em>rot</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Construct a quaternion from a rotation matrix. </p>

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00073">73</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

</div>
</div>
<a class="anchor" id="a7f25c623d95186b58f6367dcd097a5ba"></a><!-- doxytag: member="Ogre::Quaternion::Quaternion" ref="a7f25c623d95186b58f6367dcd097a5ba" args="(const Radian &amp;rfAngle, const Vector3 &amp;rkAxis)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Quaternion.html#ab58dc0c4c04d0579ce9321a719f10d5c">Ogre::Quaternion::Quaternion</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Radian.html">Radian</a> &amp;&#160;</td>
          <td class="paramname"><em>rfAngle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>rkAxis</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Construct a quaternion from an angle/axis. </p>

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00078">78</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1140011dc0793a81c55f2d078c8c964c"></a><!-- doxytag: member="Ogre::Quaternion::Quaternion" ref="a1140011dc0793a81c55f2d078c8c964c" args="(const Vector3 &amp;xaxis, const Vector3 &amp;yaxis, const Vector3 &amp;zaxis)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Quaternion.html#ab58dc0c4c04d0579ce9321a719f10d5c">Ogre::Quaternion::Quaternion</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>xaxis</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>yaxis</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>zaxis</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Construct a quaternion from 3 orthonormal local axes. </p>

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00083">83</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

</div>
</div>
<a class="anchor" id="a3ccc60338011887023b397a02a7f3336"></a><!-- doxytag: member="Ogre::Quaternion::Quaternion" ref="a3ccc60338011887023b397a02a7f3336" args="(const Vector3 *akAxis)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Quaternion.html#ab58dc0c4c04d0579ce9321a719f10d5c">Ogre::Quaternion::Quaternion</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> *&#160;</td>
          <td class="paramname"><em>akAxis</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Construct a quaternion from 3 orthonormal local axes. </p>

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00088">88</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1ca81bd9d57e43cf23582c898e5fdd34"></a><!-- doxytag: member="Ogre::Quaternion::Quaternion" ref="a1ca81bd9d57e43cf23582c898e5fdd34" args="(Real *valptr)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Quaternion.html#ab58dc0c4c04d0579ce9321a719f10d5c">Ogre::Quaternion::Quaternion</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> *&#160;</td>
          <td class="paramname"><em>valptr</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Construct a quaternion from 4 manual w/x/y/z values. </p>

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00093">93</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a8ed59783cae74b10d60c5dfab65efc46"></a><!-- doxytag: member="Ogre::Quaternion::Dot" ref="a8ed59783cae74b10d60c5dfab65efc46" args="(const Quaternion &amp;rkQ) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1Quaternion.html#a8ed59783cae74b10d60c5dfab65efc46">Ogre::Quaternion::Dot</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rkQ</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the dot product of the quaternion. </p>

</div>
</div>
<a class="anchor" id="a2967ddfe51904c9bff1b68eb3e39f0e5"></a><!-- doxytag: member="Ogre::Quaternion::equals" ref="a2967ddfe51904c9bff1b68eb3e39f0e5" args="(const Quaternion &amp;rhs, const Radian &amp;tolerance) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1Quaternion.html#a2967ddfe51904c9bff1b68eb3e39f0e5">Ogre::Quaternion::equals</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Radian.html">Radian</a> &amp;&#160;</td>
          <td class="paramname"><em>tolerance</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Equality with tolerance (tolerance is max angle difference) </p>

</div>
</div>
<a class="anchor" id="afa5a360df739f21929b2359276c2a9a5"></a><!-- doxytag: member="Ogre::Quaternion::Exp" ref="afa5a360df739f21929b2359276c2a9a5" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> <a class="el" href="classOgre_1_1Quaternion.html#afa5a360df739f21929b2359276c2a9a5">Ogre::Quaternion::Exp</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ac3328c1bb86d17e870c57d52720e2e32"></a><!-- doxytag: member="Ogre::Quaternion::FromAngleAxis" ref="ac3328c1bb86d17e870c57d52720e2e32" args="(const Radian &amp;rfAngle, const Vector3 &amp;rkAxis)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1Quaternion.html#ac3328c1bb86d17e870c57d52720e2e32">Ogre::Quaternion::FromAngleAxis</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Radian.html">Radian</a> &amp;&#160;</td>
          <td class="paramname"><em>rfAngle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>rkAxis</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Setups the quaternion using the supplied vector, and "roll" around that vector by the specified radians. </p>

<p>Referenced by <a class="el" href="OgreVector3_8h_source.html#l00651">Ogre::Vector3::getRotationTo()</a>, and <a class="el" href="OgreVector3_8h_source.html#l00599">Ogre::Vector3::randomDeviant()</a>.</p>

</div>
</div>
<a class="anchor" id="a7ad7ad40e38bf351485c2a906c3949bb"></a><!-- doxytag: member="Ogre::Quaternion::FromAxes" ref="a7ad7ad40e38bf351485c2a906c3949bb" args="(const Vector3 *akAxis)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1Quaternion.html#a7ad7ad40e38bf351485c2a906c3949bb">Ogre::Quaternion::FromAxes</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> *&#160;</td>
          <td class="paramname"><em>akAxis</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Constructs the quaternion using 3 axes, the axes are assumed to be orthonormal. </p>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1Quaternion.html#a7ad7ad40e38bf351485c2a906c3949bb" title="Constructs the quaternion using 3 axes, the axes are assumed to be orthonormal.">FromAxes</a> </dd></dl>

</div>
</div>
<a class="anchor" id="a365bc3b10308318721199a829db03887"></a><!-- doxytag: member="Ogre::Quaternion::FromAxes" ref="a365bc3b10308318721199a829db03887" args="(const Vector3 &amp;xAxis, const Vector3 &amp;yAxis, const Vector3 &amp;zAxis)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1Quaternion.html#a7ad7ad40e38bf351485c2a906c3949bb">Ogre::Quaternion::FromAxes</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>xAxis</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>yAxis</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>zAxis</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ae6c3bfed7176355cf2461567f89a15b1"></a><!-- doxytag: member="Ogre::Quaternion::FromRotationMatrix" ref="ae6c3bfed7176355cf2461567f89a15b1" args="(const Matrix3 &amp;kRot)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1Quaternion.html#ae6c3bfed7176355cf2461567f89a15b1">Ogre::Quaternion::FromRotationMatrix</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix3.html">Matrix3</a> &amp;&#160;</td>
          <td class="paramname"><em>kRot</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ab4f38aa582a50dd81c05c3e772680f6b"></a><!-- doxytag: member="Ogre::Quaternion::getPitch" ref="ab4f38aa582a50dd81c05c3e772680f6b" args="(bool reprojectAxis=true) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Radian.html">Radian</a> <a class="el" href="classOgre_1_1Quaternion.html#ab4f38aa582a50dd81c05c3e772680f6b">Ogre::Quaternion::getPitch</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>reprojectAxis</em> = <code>true</code></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Calculate the local pitch element of this quaternion. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">reprojectAxis</td><td>By default the method returns the 'intuitive' result that is, if you projected the local Z of the quaternion onto the X and Y axes, the angle between them is returned. If set to true though, the result is the actual yaw that will be used to implement the quaternion, which is the shortest possible path to get to the same orientation and may involve less axial rotation. The co-domain of the returned value is from -180 to 180 degrees. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a4d02aa80d2d2183045225a0243e659b9"></a><!-- doxytag: member="Ogre::Quaternion::getRoll" ref="a4d02aa80d2d2183045225a0243e659b9" args="(bool reprojectAxis=true) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Radian.html">Radian</a> <a class="el" href="classOgre_1_1Quaternion.html#a4d02aa80d2d2183045225a0243e659b9">Ogre::Quaternion::getRoll</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>reprojectAxis</em> = <code>true</code></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Calculate the local roll element of this quaternion. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">reprojectAxis</td><td>By default the method returns the 'intuitive' result that is, if you projected the local Y of the quaternion onto the X and Y axes, the angle between them is returned. If set to false though, the result is the actual yaw that will be used to implement the quaternion, which is the shortest possible path to get to the same orientation and may involve less axial rotation. The co-domain of the returned value is from -180 to 180 degrees. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a76afd1ec6ae605cf6a969a5e57873f5e"></a><!-- doxytag: member="Ogre::Quaternion::getYaw" ref="a76afd1ec6ae605cf6a969a5e57873f5e" args="(bool reprojectAxis=true) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Radian.html">Radian</a> <a class="el" href="classOgre_1_1Quaternion.html#a76afd1ec6ae605cf6a969a5e57873f5e">Ogre::Quaternion::getYaw</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>reprojectAxis</em> = <code>true</code></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Calculate the local yaw element of this quaternion. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">reprojectAxis</td><td>By default the method returns the 'intuitive' result that is, if you projected the local Y of the quaternion onto the X and Z axes, the angle between them is returned. If set to true though, the result is the actual yaw that will be used to implement the quaternion, which is the shortest possible path to get to the same orientation and may involve less axial rotation. The co-domain of the returned value is from -180 to 180 degrees. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a838d0736819d496073d99f3f74d0cac1"></a><!-- doxytag: member="Ogre::Quaternion::Intermediate" ref="a838d0736819d496073d99f3f74d0cac1" args="(const Quaternion &amp;rkQ0, const Quaternion &amp;rkQ1, const Quaternion &amp;rkQ2, Quaternion &amp;rka, Quaternion &amp;rkB)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void <a class="el" href="classOgre_1_1Quaternion.html#a838d0736819d496073d99f3f74d0cac1">Ogre::Quaternion::Intermediate</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rkQ0</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rkQ1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rkQ2</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rka</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rkB</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a391f1c24de70342cc0ac3945d9450ef6"></a><!-- doxytag: member="Ogre::Quaternion::Inverse" ref="a391f1c24de70342cc0ac3945d9450ef6" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> <a class="el" href="classOgre_1_1Quaternion.html#a391f1c24de70342cc0ac3945d9450ef6">Ogre::Quaternion::Inverse</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a2b1de9aebae545618e105399aeee6f39"></a><!-- doxytag: member="Ogre::Quaternion::isNaN" ref="a2b1de9aebae545618e105399aeee6f39" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1Quaternion.html#a2b1de9aebae545618e105399aeee6f39">Ogre::Quaternion::isNaN</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Check whether this quaternion contains valid values. </p>

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00306">306</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

<p>References <a class="el" href="OgreMath_8h_source.html#l00290">Ogre::Math::isNaN()</a>.</p>

</div>
</div>
<a class="anchor" id="aa446f6210a2446c7ff3a9358635988c4"></a><!-- doxytag: member="Ogre::Quaternion::Log" ref="aa446f6210a2446c7ff3a9358635988c4" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> <a class="el" href="classOgre_1_1Quaternion.html#aa446f6210a2446c7ff3a9358635988c4">Ogre::Quaternion::Log</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a16987149991882e148170fe3f1c7da4b"></a><!-- doxytag: member="Ogre::Quaternion::nlerp" ref="a16987149991882e148170fe3f1c7da4b" args="(Real fT, const Quaternion &amp;rkP, const Quaternion &amp;rkQ, bool shortestPath=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> <a class="el" href="classOgre_1_1Quaternion.html#a16987149991882e148170fe3f1c7da4b">Ogre::Quaternion::nlerp</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>fT</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rkP</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rkQ</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>shortestPath</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Performs Normalised linear interpolation between two quaternions, and returns the result. </p>
<p>nlerp ( 0.0f, A, B ) = A nlerp ( 1.0f, A, B ) = B </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Nlerp is faster than Slerp. Nlerp has the proprieties of being commutative (</dd></dl>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1Quaternion.html#ab0c47f1a7308ac4c17db9f9ddb6e4a72" title="Performs Spherical linear interpolation between two quaternions, and returns the result.">Slerp</a>; commutativity is desired in certain places, like IK animation), and being torque-minimal (unless shortestPath=false). However, it's performing the interpolation at non-constant velocity; sometimes this is desired, sometimes it is not. Having a non-constant velocity can produce a more natural rotation feeling without the need of tweaking the weights; however if your scene relies on the timing of the rotation or assumes it will point at a specific angle at a specific weight value, <a class="el" href="classOgre_1_1Quaternion.html#ab0c47f1a7308ac4c17db9f9ddb6e4a72" title="Performs Spherical linear interpolation between two quaternions, and returns the result.">Slerp</a> is a better choice. </dd></dl>

</div>
</div>
<a class="anchor" id="a17a0e63655eda5e7d77522d45033668c"></a><!-- doxytag: member="Ogre::Quaternion::Norm" ref="a17a0e63655eda5e7d77522d45033668c" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1Quaternion.html#a17a0e63655eda5e7d77522d45033668c">Ogre::Quaternion::Norm</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="aee94ec9c7de50fe7f774ae4c7e760b65"></a><!-- doxytag: member="Ogre::Quaternion::normalise" ref="aee94ec9c7de50fe7f774ae4c7e760b65" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1Quaternion.html#aee94ec9c7de50fe7f774ae4c7e760b65">Ogre::Quaternion::normalise</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Normalises this quaternion, and returns the previous length. </p>

<p>Referenced by <a class="el" href="OgreVector3_8h_source.html#l00651">Ogre::Vector3::getRotationTo()</a>.</p>

</div>
</div>
<a class="anchor" id="aaac827806910efa70a5deaa6d75bf3e1"></a><!-- doxytag: member="Ogre::Quaternion::operator!=" ref="aaac827806910efa70a5deaa6d75bf3e1" args="(const Quaternion &amp;rhs) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::Quaternion::operator!= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00192">192</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

<p>References <a class="el" href="OgreMemorySTLAllocator_8h_source.html#l00183">Ogre::operator==()</a>.</p>

</div>
</div>
<a class="anchor" id="a8b6d98bd2af93072ee558a2fb8e41b61"></a><!-- doxytag: member="Ogre::Quaternion::operator*" ref="a8b6d98bd2af93072ee558a2fb8e41b61" args="(const Quaternion &amp;rkQ) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> Ogre::Quaternion::operator* </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rkQ</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a629aca4f4c26ecf88b5755872629cf0a"></a><!-- doxytag: member="Ogre::Quaternion::operator*" ref="a629aca4f4c26ecf88b5755872629cf0a" args="(Real fScalar) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> Ogre::Quaternion::operator* </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>fScalar</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="aa453e5f1a2e1de06bfacf89433a9b529"></a><!-- doxytag: member="Ogre::Quaternion::operator*" ref="aa453e5f1a2e1de06bfacf89433a9b529" args="(const Vector3 &amp;rkVector) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> Ogre::Quaternion::operator* </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>rkVector</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Rotation of a vector by a quaternion. </p>

</div>
</div>
<a class="anchor" id="a3c71782cbc1d79c25d1374ffde29f918"></a><!-- doxytag: member="Ogre::Quaternion::operator+" ref="a3c71782cbc1d79c25d1374ffde29f918" args="(const Quaternion &amp;rkQ) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> Ogre::Quaternion::operator+ </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rkQ</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ab07f890193a498d4091c3cbc6799ae4f"></a><!-- doxytag: member="Ogre::Quaternion::operator&#45;" ref="ab07f890193a498d4091c3cbc6799ae4f" args="(const Quaternion &amp;rkQ) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> Ogre::Quaternion::operator- </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rkQ</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a425964da3f7cc72e656d68cec30833d0"></a><!-- doxytag: member="Ogre::Quaternion::operator&#45;" ref="a425964da3f7cc72e656d68cec30833d0" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> Ogre::Quaternion::operator- </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a6367b543cf0d073d893139dd503b4fbd"></a><!-- doxytag: member="Ogre::Quaternion::operator=" ref="a6367b543cf0d073d893139dd503b4fbd" args="(const Quaternion &amp;rkQ)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a>&amp; Ogre::Quaternion::operator= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rkQ</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00172">172</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

<p>References <a class="el" href="OgreQuaternion_8h_source.html#l00303">w</a>, <a class="el" href="OgreQuaternion_8h_source.html#l00303">x</a>, <a class="el" href="OgreQuaternion_8h_source.html#l00303">y</a>, and <a class="el" href="OgreQuaternion_8h_source.html#l00303">z</a>.</p>

</div>
</div>
<a class="anchor" id="aa20c618a3b4b67d22d2cfd64ba2c8f3b"></a><!-- doxytag: member="Ogre::Quaternion::operator==" ref="aa20c618a3b4b67d22d2cfd64ba2c8f3b" args="(const Quaternion &amp;rhs) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::Quaternion::operator== </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00187">187</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

<p>References <a class="el" href="OgreQuaternion_8h_source.html#l00303">w</a>, <a class="el" href="OgreQuaternion_8h_source.html#l00303">x</a>, <a class="el" href="OgreQuaternion_8h_source.html#l00303">y</a>, and <a class="el" href="OgreQuaternion_8h_source.html#l00303">z</a>.</p>

</div>
</div>
<a class="anchor" id="a3f9320930fd5110028abf48c78a89622"></a><!-- doxytag: member="Ogre::Quaternion::operator[]" ref="a3f9320930fd5110028abf48c78a89622" args="(const size_t i) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> Ogre::Quaternion::operator[] </td>
          <td>(</td>
          <td class="paramtype">const size_t&#160;</td>
          <td class="paramname"><em>i</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Array accessor operator. </p>

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00109">109</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

</div>
</div>
<a class="anchor" id="a074aea0da7fabfde89d204a1f0f0121b"></a><!-- doxytag: member="Ogre::Quaternion::operator[]" ref="a074aea0da7fabfde89d204a1f0f0121b" args="(const size_t i)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&amp; Ogre::Quaternion::operator[] </td>
          <td>(</td>
          <td class="paramtype">const size_t&#160;</td>
          <td class="paramname"><em>i</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Array accessor operator. </p>

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00117">117</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

</div>
</div>
<a class="anchor" id="aecce24dd0096766de0c96c13b195b197"></a><!-- doxytag: member="Ogre::Quaternion::ptr" ref="aecce24dd0096766de0c96c13b195b197" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>* <a class="el" href="classOgre_1_1Quaternion.html#aecce24dd0096766de0c96c13b195b197">Ogre::Quaternion::ptr</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Pointer accessor for direct copying. </p>

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00125">125</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

<p>Referenced by <a class="el" href="OgreAnimable_8h_source.html#l00112">Ogre::AnimableValue::setAsBaseValue()</a>.</p>

</div>
</div>
<a class="anchor" id="ab4b5bc328439a4f96d1b4b413fcf87cc"></a><!-- doxytag: member="Ogre::Quaternion::ptr" ref="ab4b5bc328439a4f96d1b4b413fcf87cc" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>* <a class="el" href="classOgre_1_1Quaternion.html#aecce24dd0096766de0c96c13b195b197">Ogre::Quaternion::ptr</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Pointer accessor for direct copying. </p>

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00131">131</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab0c47f1a7308ac4c17db9f9ddb6e4a72"></a><!-- doxytag: member="Ogre::Quaternion::Slerp" ref="ab0c47f1a7308ac4c17db9f9ddb6e4a72" args="(Real fT, const Quaternion &amp;rkP, const Quaternion &amp;rkQ, bool shortestPath=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> <a class="el" href="classOgre_1_1Quaternion.html#ab0c47f1a7308ac4c17db9f9ddb6e4a72">Ogre::Quaternion::Slerp</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>fT</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rkP</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rkQ</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>shortestPath</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Performs Spherical linear interpolation between two quaternions, and returns the result. </p>
<p>Slerp ( 0.0f, A, B ) = A Slerp ( 1.0f, A, B ) = B </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>Interpolated quaternion </dd></dl>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Slerp has the proprieties of performing the interpolation at constant velocity, and being torque-minimal (unless shortestPath=false). However, it's NOT commutative, which means Slerp ( 0.75f, A, B ) != Slerp ( 0.25f, B, A ); therefore be careful if your code relies in the order of the operands. This is specially important in IK animation. </dd></dl>

</div>
</div>
<a class="anchor" id="a25fb3bc0f11e6a676fb5c47347a79579"></a><!-- doxytag: member="Ogre::Quaternion::SlerpExtraSpins" ref="a25fb3bc0f11e6a676fb5c47347a79579" args="(Real fT, const Quaternion &amp;rkP, const Quaternion &amp;rkQ, int iExtraSpins)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> <a class="el" href="classOgre_1_1Quaternion.html#a25fb3bc0f11e6a676fb5c47347a79579">Ogre::Quaternion::SlerpExtraSpins</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>fT</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rkP</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rkQ</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>iExtraSpins</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1Quaternion.html#ab0c47f1a7308ac4c17db9f9ddb6e4a72" title="Performs Spherical linear interpolation between two quaternions, and returns the result.">Slerp</a>. It adds extra "spins" (i.e. rotates several times) specified by parameter 'iExtraSpins' while interpolating before arriving to the final values </dd></dl>

</div>
</div>
<a class="anchor" id="a5f43da8b8aa579e02035eecff89e16a5"></a><!-- doxytag: member="Ogre::Quaternion::Squad" ref="a5f43da8b8aa579e02035eecff89e16a5" args="(Real fT, const Quaternion &amp;rkP, const Quaternion &amp;rkA, const Quaternion &amp;rkB, const Quaternion &amp;rkQ, bool shortestPath=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> <a class="el" href="classOgre_1_1Quaternion.html#a5f43da8b8aa579e02035eecff89e16a5">Ogre::Quaternion::Squad</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>fT</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rkP</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rkA</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rkB</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rkQ</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>shortestPath</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a54dcd575915c7b7ddb65b8cb249de521"></a><!-- doxytag: member="Ogre::Quaternion::swap" ref="a54dcd575915c7b7ddb65b8cb249de521" args="(Quaternion &amp;other)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1Quaternion.html#a54dcd575915c7b7ddb65b8cb249de521">Ogre::Quaternion::swap</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>other</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Exchange the contents of this quaternion with another. </p>

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00100">100</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

<p>References <a class="el" href="OgreSmallVector_8h_source.html#l00802">std::swap()</a>, <a class="el" href="OgreQuaternion_8h_source.html#l00303">w</a>, <a class="el" href="OgreQuaternion_8h_source.html#l00303">x</a>, <a class="el" href="OgreQuaternion_8h_source.html#l00303">y</a>, and <a class="el" href="OgreQuaternion_8h_source.html#l00303">z</a>.</p>

</div>
</div>
<a class="anchor" id="a9c516d6b499410b2fc72524026d3a124"></a><!-- doxytag: member="Ogre::Quaternion::ToAngleAxis" ref="a9c516d6b499410b2fc72524026d3a124" args="(Radian &amp;rfAngle, Vector3 &amp;rkAxis) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1Quaternion.html#a9c516d6b499410b2fc72524026d3a124">Ogre::Quaternion::ToAngleAxis</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Radian.html">Radian</a> &amp;&#160;</td>
          <td class="paramname"><em>rfAngle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>rkAxis</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a77b776c2f81d371549927b0f79478eb9"></a><!-- doxytag: member="Ogre::Quaternion::ToAngleAxis" ref="a77b776c2f81d371549927b0f79478eb9" args="(Degree &amp;dAngle, Vector3 &amp;rkAxis) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1Quaternion.html#a9c516d6b499410b2fc72524026d3a124">Ogre::Quaternion::ToAngleAxis</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Degree.html">Degree</a> &amp;&#160;</td>
          <td class="paramname"><em>dAngle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>rkAxis</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00143">143</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

</div>
</div>
<a class="anchor" id="a82b3a7b187451d70e1522b54718deadf"></a><!-- doxytag: member="Ogre::Quaternion::ToAxes" ref="a82b3a7b187451d70e1522b54718deadf" args="(Vector3 *akAxis) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1Quaternion.html#a82b3a7b187451d70e1522b54718deadf">Ogre::Quaternion::ToAxes</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> *&#160;</td>
          <td class="paramname"><em>akAxis</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the 3 orthonormal axes defining the quaternion. </p>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1Quaternion.html#a7ad7ad40e38bf351485c2a906c3949bb" title="Constructs the quaternion using 3 axes, the axes are assumed to be orthonormal.">FromAxes</a> </dd></dl>

</div>
</div>
<a class="anchor" id="afc19f98e4b1cf72072a5da398c8702ba"></a><!-- doxytag: member="Ogre::Quaternion::ToAxes" ref="afc19f98e4b1cf72072a5da398c8702ba" args="(Vector3 &amp;xAxis, Vector3 &amp;yAxis, Vector3 &amp;zAxis) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1Quaternion.html#a82b3a7b187451d70e1522b54718deadf">Ogre::Quaternion::ToAxes</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>xAxis</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>yAxis</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>zAxis</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a7e6b9955074bf92c2b778dc0307769a2"></a><!-- doxytag: member="Ogre::Quaternion::ToRotationMatrix" ref="a7e6b9955074bf92c2b778dc0307769a2" args="(Matrix3 &amp;kRot) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1Quaternion.html#a7e6b9955074bf92c2b778dc0307769a2">Ogre::Quaternion::ToRotationMatrix</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Matrix3.html">Matrix3</a> &amp;&#160;</td>
          <td class="paramname"><em>kRot</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Referenced by <a class="el" href="OgreMatrix4_8h_source.html#l00131">Ogre::Matrix4::Matrix4()</a>.</p>

</div>
</div>
<a class="anchor" id="a9bac18de9a5b0935834e045b2a755d4f"></a><!-- doxytag: member="Ogre::Quaternion::UnitInverse" ref="a9bac18de9a5b0935834e045b2a755d4f" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> <a class="el" href="classOgre_1_1Quaternion.html#a9bac18de9a5b0935834e045b2a755d4f">Ogre::Quaternion::UnitInverse</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ad6d7ef864ec7bf39db133a0fd67cce26"></a><!-- doxytag: member="Ogre::Quaternion::xAxis" ref="ad6d7ef864ec7bf39db133a0fd67cce26" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> <a class="el" href="classOgre_1_1Quaternion.html#ad6d7ef864ec7bf39db133a0fd67cce26">Ogre::Quaternion::xAxis</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the X orthonormal axis defining the quaternion. </p>
<p>Same as doing xAxis = <a class="el" href="classOgre_1_1Vector3.html#a0c21d1f120c5eab83aa966e5de1df311">Vector3::UNIT_X</a> * this. Also called the local X-axis </p>

</div>
</div>
<a class="anchor" id="a62b05272a53c6ee664d7ed6760ec3744"></a><!-- doxytag: member="Ogre::Quaternion::yAxis" ref="a62b05272a53c6ee664d7ed6760ec3744" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> <a class="el" href="classOgre_1_1Quaternion.html#a62b05272a53c6ee664d7ed6760ec3744">Ogre::Quaternion::yAxis</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the Y orthonormal axis defining the quaternion. </p>
<p>Same as doing yAxis = <a class="el" href="classOgre_1_1Vector3.html#a8d1a1f7af535bcc8d9c78b1732bc1b90">Vector3::UNIT_Y</a> * this. Also called the local Y-axis </p>

</div>
</div>
<a class="anchor" id="a6c1b8112a4af61982f0feb6fe187851c"></a><!-- doxytag: member="Ogre::Quaternion::zAxis" ref="a6c1b8112a4af61982f0feb6fe187851c" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> <a class="el" href="classOgre_1_1Quaternion.html#a6c1b8112a4af61982f0feb6fe187851c">Ogre::Quaternion::zAxis</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the Z orthonormal axis defining the quaternion. </p>
<p>Same as doing zAxis = <a class="el" href="classOgre_1_1Vector3.html#ad25aed2e9367cfa879d3e3c231c5a136">Vector3::UNIT_Z</a> * this. Also called the local Z-axis </p>

</div>
</div>
<hr/><h2>Friends And Related Function Documentation</h2>
<a class="anchor" id="ab929010aac9fae8a14008a7213d9d419"></a><!-- doxytag: member="Ogre::Quaternion::operator*" ref="ab929010aac9fae8a14008a7213d9d419" args="(Real fScalar, const Quaternion &amp;rkQ)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> friend <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> operator* </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>fScalar</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rkQ</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [friend]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a2a92fc4c7d55783c70ef6f633f3cac89"></a><!-- doxytag: member="Ogre::Quaternion::operator&lt;&lt;" ref="a2a92fc4c7d55783c70ef6f633f3cac89" args="(std::ostream &amp;o, const Quaternion &amp;q)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> friend std::ostream&amp; operator&lt;&lt; </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>o</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>q</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [friend]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Function for writing to a stream. </p>
<p>Outputs "Quaternion(w, x, y, z)" with w,x,y,z being the member values of the quaternion. </p>

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00315">315</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a441b8d52549e1dedec27420325a313ef"></a><!-- doxytag: member="Ogre::Quaternion::IDENTITY" ref="a441b8d52549e1dedec27420325a313ef" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> <a class="el" href="classOgre_1_1Quaternion.html#a441b8d52549e1dedec27420325a313ef">Ogre::Quaternion::IDENTITY</a><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00301">301</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

<p>Referenced by <a class="el" href="OgreVector3_8h_source.html#l00651">Ogre::Vector3::getRotationTo()</a>.</p>

</div>
</div>
<a class="anchor" id="a6b53296360cc166c62533cff8f1edcc2"></a><!-- doxytag: member="Ogre::Quaternion::msEpsilon" ref="a6b53296360cc166c62533cff8f1edcc2" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1Quaternion.html#a6b53296360cc166c62533cff8f1edcc2">Ogre::Quaternion::msEpsilon</a><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Cutoff for sine near zero. </p>

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00297">297</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

</div>
</div>
<a class="anchor" id="af3424f1e07092c0ffe293d18b277a04f"></a><!-- doxytag: member="Ogre::Quaternion::w" ref="af3424f1e07092c0ffe293d18b277a04f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1Quaternion.html#af3424f1e07092c0ffe293d18b277a04f">Ogre::Quaternion::w</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00303">303</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

<p>Referenced by <a class="el" href="OgreVector3_8h_source.html#l00651">Ogre::Vector3::getRotationTo()</a>, <a class="el" href="OgreQuaternion_8h_source.html#l00172">operator=()</a>, <a class="el" href="OgreQuaternion_8h_source.html#l00187">operator==()</a>, and <a class="el" href="OgreQuaternion_8h_source.html#l00100">swap()</a>.</p>

</div>
</div>
<a class="anchor" id="a32c5680516b41bc4ba3159bf4d4abaf1"></a><!-- doxytag: member="Ogre::Quaternion::x" ref="a32c5680516b41bc4ba3159bf4d4abaf1" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1Quaternion.html#a32c5680516b41bc4ba3159bf4d4abaf1">Ogre::Quaternion::x</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00303">303</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

<p>Referenced by <a class="el" href="OgreVector3_8h_source.html#l00651">Ogre::Vector3::getRotationTo()</a>, <a class="el" href="OgreQuaternion_8h_source.html#l00172">operator=()</a>, <a class="el" href="OgreQuaternion_8h_source.html#l00187">operator==()</a>, and <a class="el" href="OgreQuaternion_8h_source.html#l00100">swap()</a>.</p>

</div>
</div>
<a class="anchor" id="aa7328cd3883a92ee9c9322805d038f11"></a><!-- doxytag: member="Ogre::Quaternion::y" ref="aa7328cd3883a92ee9c9322805d038f11" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1Quaternion.html#aa7328cd3883a92ee9c9322805d038f11">Ogre::Quaternion::y</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00303">303</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

<p>Referenced by <a class="el" href="OgreVector3_8h_source.html#l00651">Ogre::Vector3::getRotationTo()</a>, <a class="el" href="OgreQuaternion_8h_source.html#l00172">operator=()</a>, <a class="el" href="OgreQuaternion_8h_source.html#l00187">operator==()</a>, and <a class="el" href="OgreQuaternion_8h_source.html#l00100">swap()</a>.</p>

</div>
</div>
<a class="anchor" id="a31ec84a931236554c0c17e37bf5ace97"></a><!-- doxytag: member="Ogre::Quaternion::z" ref="a31ec84a931236554c0c17e37bf5ace97" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1Quaternion.html#a31ec84a931236554c0c17e37bf5ace97">Ogre::Quaternion::z</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00303">303</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

<p>Referenced by <a class="el" href="OgreVector3_8h_source.html#l00651">Ogre::Vector3::getRotationTo()</a>, <a class="el" href="OgreQuaternion_8h_source.html#l00172">operator=()</a>, <a class="el" href="OgreQuaternion_8h_source.html#l00187">operator==()</a>, and <a class="el" href="OgreQuaternion_8h_source.html#l00100">swap()</a>.</p>

</div>
</div>
<a class="anchor" id="a44f3c000c8f1ea2759c2e724e04bf86b"></a><!-- doxytag: member="Ogre::Quaternion::ZERO" ref="a44f3c000c8f1ea2759c2e724e04bf86b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> <a class="el" href="classOgre_1_1Quaternion.html#a44f3c000c8f1ea2759c2e724e04bf86b">Ogre::Quaternion::ZERO</a><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreQuaternion_8h_source.html#l00300">300</a> of file <a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreQuaternion_8h_source.html">OgreQuaternion.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:02
</p>
</body>
</html>
